AddMoneyToUserEvent = {};
AddMoneyToUserEvent_mt = Class(AddMoneyToUserEvent, Event);
InitEventClass(AddMoneyToUserEvent, "AddMoneyToUserEvent");

function AddMoneyToUserEvent:emptyNew()
  local self = Event:new(AddMoneyToUserEvent_mt);
  return self;
end;

function AddMoneyToUserEvent:new(amount, userIdReceiver, statName)
  local self = AddMoneyToUserEvent:emptyNew();
  self.amount = amount;
  self.userIdReceiver = userIdReceiver;
  self.statName = statName
  return self;
end;

function AddMoneyToUserEvent:readStream(streamId, connection)
  self.amount = streamReadFloat32(streamId);
  self.userIdReceiver = streamReadInt32(streamId);
  self.statName = streamReadString(streamId);
  self:run(connection);
end;

function AddMoneyToUserEvent:writeStream(streamId, connection)
  streamWriteFloat32(streamId, self.amount);
  streamWriteInt32(streamId, self.userIdReceiver);
  streamWriteString(streamId, self.statName);
end;

function AddMoneyToUserEvent:run(connection)
	if not connection:getIsServer() then
		do
			if self.statName == nil then
				self.statName = ""
			end

			if self.userIdReceiver == 0 then				
				local shared_money = self.amount / #g_currentMission.users
				--print("Geld verteilen: "..tostring(self.amount).." fr jeden "..tostring(shared_money))
				for i = 1, table.getn(g_currentMission.users) do
					if self.statName == "" then
						g_currentMission:addMoney(shared_money, g_currentMission.users[i].userId);
					else
						g_currentMission:addMoney(shared_money, g_currentMission.users[i].userId, self.statName);
					end
				end;
				
			else
				--print("Geld geben "..tostring(self.amount).." an "..tostring(self.userIdReceiver))
				
				if g_currentMission.users[self.userIdReceiver] == nil then
				
					for i = 1, table.getn(g_currentMission.users) do

						if g_currentMission.users[i].nickname == self.userIdReceiver then
							--userid = g_currentMission.users[i].userId
							self.userIdReceiver = g_currentMission.users[i].userId
							break;
						end
					end;
				end
				
				if self.statName == "" then
					g_currentMission:addMoney(self.amount, self.userIdReceiver);
				else
					g_currentMission:addMoney(self.amount, self.userIdReceiver, self.statName);
				end
			end
		end;
	else
		--print("Error: SendMoneyToUserEvent is a client to server only event");
	end;
end;